
#include "PimientoDebug.h"

void PimientoDebug::setLevel(uint8_t level) {
    _level = level;
}

uint8_t PimientoDebug::getLevel() {
    return _level;
}

int PimientoDebug::available(void) {
    if (_level == 0) { return 0; }
    return _stream->available();
}

int PimientoDebug::peek(void) {
    if (_level == 0) { return 0; }
    return _stream->peek();
}

int PimientoDebug::read(void) {
    if (_level == 0) { return 0; }
    return _stream->read();
}

int PimientoDebug::availableForWrite(void) {
    if (_level == 0) { return 0; }
    return _stream->availableForWrite();
}

void PimientoDebug::flush(void) {
    if (_level == 0) { return; }
    _stream->flush();
}

size_t PimientoDebug::write(uint8_t t) {
    if (_level == 0) { return 0; }
    return _stream->write(t);
}

size_t PimientoDebug::write(unsigned long n) {
    if (_level == 0) { return 0; }
    return _stream->write(n);
}

size_t PimientoDebug::write(long n) {
    if (_level == 0) { return 0; }
    return _stream->write(n);
}

size_t PimientoDebug::write(unsigned int n) {
    if (_level == 0) { return 0; }
    return _stream->write(n);
}

size_t PimientoDebug::write(int n) {
    if (_level == 0) { return 0; }
    return _stream->write(n);
}
