/*  Copyright (c) 2024 by soruce <soruce ~ AT ~ soruce.net>

    This file is part of the Arduino PimientoClockLib Library.

    The Arduino PimientoClockLib Library is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The Arduino PimientoClockLib Library is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Arduino PimientoClockLib Library.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef PIMIENTO_DEBUG_H
#define PIMIENTO_DEBUG_H

#include <Arduino.h>

class PimientoDebug : public Stream {

    public:

        void setLevel(uint8_t level);
        uint8_t getLevel();

        int available(void);
        int peek(void);
        int read(void);
        int availableForWrite(void);
        void flush(void);
        size_t write(uint8_t t);
        size_t write(unsigned long n);
        size_t write(long n);
        size_t write(unsigned int n);
        size_t write(int n);

        // using Print::write; // pull in write(str) and write(buf, size) from Print
        // operator bool() { return true; }
    private:
        uint8_t _level = 0;
        Stream *_stream = &Serial;
};

#endif // PIMIENTO_DEBUG_H